Status: Open
Priority: Normal
Assignee:

Target version:

Description

Float [l Infinity 10000000000000000F10num 00000000
0000000000000 ¢ 00 peLanum 000000000000000

00000ooooooo

E{ﬁﬁﬁgnﬂgnﬂgz[lguﬂdag%yu%%ﬂ[II][II][II][II][II][II][II][II][II][II]

$ grep 'DBL2NUM.*HUGE_VAL' $(git ls-files | awk '/\.c$/ && !/”(spec|ext\/-test=)\//"') | wc -1
$ egre;:—— '-Float::INFINITY' $(git ls-files | egrep '~ (liblext)/.*\.rb$') | wc -1

HHHDInfinityI][II][II][II][II][II][II][II][II][II][II][II][II][II][II]

00000000000000000000 benchmark-driver 1000000000
00000 infinity D00000000D000000000000000000
(0000D00DD000D0000010%000000000) O0DOOO

Calaulaglig = e
compare-ruby built-ruby
positive_infinity 34.531M 62.540M i/s - 3.000M times in 0.195822s 0.107997s
negative_infinity 42 .581M 94.234M i/s - 3.000M times in 0.159061s 0.071766s
flonum 142.010M 150.967M i/s - 3.000M times in 0.047544s 0.045120s
heap 33.952M 34.629M i/s - 3.000M times in 0.199321s 0.195063s
Comparison:

positive_infinity
built-ruby: 62540441.7 i/s
compare-ruby: 34530877.6 i/s - 1.81x slower

negative_infinity
built-ruby: 94234135.1 i/s
compare-ruby: 42580998.6 i/s - 2.21x slower

flonum
built-ruby: 150967185.7 i/s
compare-ruby: 142010146.8 i/s - 1.06x slower

heap
built-ruby: 34629459.1 i/s
compare-ruby: 33952081.8 i/s - 1.02x slower

History

#1 - 12/19/2018 08:13 AM - shuuijii (Shuji KOBAYASHI)
- Subject changed from Float Infinity ni to Floatl Infinity ...

#2 - 12/19/2018 08:54 AM - shuuijii (Shuji KOBAYASHI)

- Backport deleted (2.4: UNKNOWN, 2.5: UNKNOWN)

- ruby -v deleted (ruby 2.6.0rc2 (2018-12-15 trunk 66408) [x86_64-linux])

- Subject changed from Float Infinity ... to FloatU Infinity 000000000000
- Tracker changed from Bug to Feature
- File benchmark.yml added
- File use-predefined-infinity.patch added

#3 - 12/19/2018 09:01 AM - shuuijii (Shuji KOBAYASHI)

- Description updated

#4 - 12/20/2018 12:52 AM - ko1 (Koichi Sasada)
(00000000000000DOD000OD00DOD00DOD00DODODDO

0000000000FIonum 0000DODOD heap 000000000 isin() 0000000Dins 00000000 allocate 00 inf 0000000000000000D00

if (isinf(d)) {

return d < 0 ? rb_float_negative_infinity : rb_float_positive_infinity;

}

000000Disinf(e) 000000O0DO0DO0O0DO0DOODO0DODO0DOD
00000000 heap allocate 000000isinf(d) check D00000000000000000000000000

0000000000 2% 000D00O000000000000D0...Oneap 000000000000000000000heap
000o00ooobooooooDonDoonoonDannoO0DO0DO00DO0DO0DD00DO0Da

qoooooonoooooo
rb_global_variable (&rb_float_negative_infinity);
rb_float_negative_infinity = rb_float_new_in_heap(-HUGE_VAL);
(1) rb_global_variable 000rb_gc_register_mark_object IIOOOOOOO0000000000000
(2) Infinity 000000000 Negativelnfinity D00000000000000000000
benchmark-driver 000000000000000000000000000000000DODODODOOOODD
#5 - 12/20/2018 02:27 PM - shuuijii (Shuji KOBAYASHI)
- File use-predefined-infinity-2.patch added
doooooooooooooooDooO
#00000000000000000
noooooooooooon

rb_global_variable (&rb_float_negative_infinity);
rb_float_negative_infinity = rb_float_new_in_heap (-HUGE_VAL) ;

(1) rb_global_variable DDDDrb_gc_register_mark_object 000000DDDDDDDDDDDDDDDD

1000000000000000000000000000n00a (oo
doc/extention.rdoc N0000000000000000000000000#9894
000000000000my0
qoooooonoooooo

(2) Infinity 000000000 Negativelnfinity 100000000000000000000
000 Float:NEGATIVE_INFINITY 00000000000000- 000000
00000Java 0 JavaScript 00 POSITIVE_INTINITY  NEGATIVE_INFINITY [I
0ooo000ooooooonn

000000oDoDoooononoDoDODODODODO00O0nOnODnaDg

000DoDobooooooo

0000000000FIonum 0ODODODOD heap 000000000 isin() 0O0O000Dins 00000000 allocate 00 inf 000000000000000000
heap 000000000000000000000neap 000000000000ODODO000DODODODODODODODODDODODODODODODODODD

00000o0oonoobonooo
0000000000 2% 00DOODOODDOODOODDOCDA...D

0000000000000000000000000000000a0...o00
0000000ooDonoonoohonooDonoononDoD

benchmark-driver 1000000000000000000000000000000000DO0DOO0ODO0D

000000000000000 (yAML O toop_count 000000) 0O0OD
DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
00000000000000000000000000000000000%000
00000c 0000000000000000000000n000000non
0000000000O00000n00o0O... (hoboDoDoDooooD
0000oDoDonoog...o

Files

use-predefined-infinity.patch 8.97 KB 12/19/2018 shuujii (Shuji KOBAYASHI)
benchmark.yml 192 Bytes 12/19/2018 shuujii (Shuji KOBAYASHI)
use-predefined-infinity-2.patch 8.97 KB 12/20/2018 shuujii (Shuji KOBAYASHI)
